;--------------------------------------
; IDE64 Patch for C64 game '3 stooges'
; 20.9.1998 J.Soucek
; Verze 0.3
;--------------------------------------

                * =  $1000

                JMP     start_load
;

loc_1003      = *
                STA     byte_105C
                STX     byte_105D
                STY     loc_102B+2     ;cil: $xx.. (hi)

                PLA     ;vybere navratovou hodnotu
                TAX     
                PLA     
                TAY

                PLA     
                STA     loc_102B+1
                PLA     
                STA     loc_1028+2
                PLA     
                STA     loc_1028+1
                LDA     #0
                STA     byte_105A
                STA     byte_105B

                TYA     ;vrati navratovou hodnotu
                PHA     
                TXA     
                PHA     

loc_1028        = *
                LDA     $FFFF
loc_102B        STA     $FFFF

                INC     byte_105A
                BNE     loc_1036
                INC     byte_105B
loc_1036        = *
                LDA     byte_105A
                CMP     byte_105C
                BNE     loc_1047
                LDA     byte_105B
                CMP     byte_105D
                BNE     loc_1047
                RTS     
loc_1047        = *
                INC     loc_1028+1
                BNE     loc_104F
                INC     loc_1028+2

loc_104F        = *
                INC     loc_102B+1
                BNE     loc_1057
                INC     loc_102B+2

loc_1057        = *
                JMP     loc_1028
;--------------------------------------                
byte_105A     .BYTE 0
byte_105B     .BYTE 0
byte_105C     .BYTE 0
byte_105D     .BYTE 0
;--------------------------------------
sub_105E        = *
                LDA     #$7F            ;127 - zakazuje ext.preruseni
                STA     $DC0D           ;Interrupt control register
                LDA     $DC0D
                SEI     
                LDA     0               ;bity 0 a 1 portu $01 jako vstupy
                ORA     #3              ;defaultne tak jsou
                STA     0

                LDA     1
                STA     byte_1089
                AND     #$FC            ;vsude RAM
                STA     1
                RTS     
;--------------------------------------
sub_1077        = *
                LDA     0               ;po resetu je $EF
                ORA     #3
                STA     0
                LDA     byte_1089
                STA     1
                LDA     #$81
                STA     $DC0D
                CLI     
                RTS
;--------------------------------------
byte_1089     .BYTE 0                 ;puvodni obsah $01
;--------------------------------------

start_load      = *
                LDA     #0
                STA     $D020
                STA     $D021
                LDA     $D011         
                AND     #$6F          ;vypne obrazovku
                STA     $D011
                
                ;----------------------
                ;----------------------
                
                ldx #0
copy_load_routine = *
                lda load_routine,x
                sta $cd00,x
                inx
                bne copy_load_routine
                
                lda $ba
                cmp #8
                bcs default_dr_num
                lda #8
default_dr_num  = *
                sta $cd0b             ;drive number

                ;----------------------
                ;----------------------

                LDX     #$07            ;file "07;0d"
                LDY     #$0D
                JSR     $CD00           ;Load file
                
                JSR     sub_105E      ;vypina ROM + IRQ

                LDA     #$00          ;cil: $..xx (low)
                PHA     
                LDA     #$C0          ;zdroj: $xx.. (hi)
                PHA     
                LDA     #$00          ;zdroj: $..xx (low)
                PHA     
                LDY     #$D0          ;cil: $xx.. (hi)

                LDA     #$00          ;delka  low
                LDX     #$10          ;delka  hi

                JSR     loc_1003      ;Copy $c000-cfff na $d000

                JSR     sub_1077      ;Vraci puvodni $01 + zap. IRQ

                LDX     #$21            ;file "21;10"
                LDY     #$10
                JSR     $CD00           ;Load file

                LDA     #0
                JMP     $C000
;--------------------------------------
load_routine    = *
                .binary "cd00_3.o64"    ;to $cdec