;--------------------------------------
; IDE64 patch for C64 game '3 stooges'
; part 2
; 20.9.1998 J.Soucek
; Verze: 0.3
;--------------------------------------
open      = $ffc0
close     = $ffc3
setnam    = $ffbd
setlfs    = $ffba
chkin     = $ffc6
chrin     = $ffcf

                * =  $cd00

                JMP start
;--------------------------------------
byte_CD03       .BYTE $16               ; cislo "strany" ???
a0              .text "00;00.0"         ; Filename

byte_CD0B       .BYTE 12                ; Aktualni Cislo zarizeni $CD73

byte_CD0C       .BYTE $23               ; Pom. Prvni cislo
byte_CD0D       .BYTE $23               ; Pom. Druhe cislo
                .BYTE $23               ; ???
                .BYTE $23               ; ???

;--------------------------------------
; Prevede Cislo na ASCII Hodnoty
; Vstup: A
; Vystup: X - ASCII hodnota horni pulbyte
;         Y - ASCII spodni pulbyte
;--------------------------------------
sub_CD10        = *
                PHA     
                LSR     A               
                LSR     A
                LSR     A
                LSR     A               ; Horni pulbyte
                JSR     sub_CD1A
                TAX     
                PLA     

sub_CD1A        = *
                AND     #$0F
                ORA     #$30
                CMP     #$3A
                BCC     loc_CD24
                ADC     #6
loc_CD24        = *
                TAY     
                RTS     

;--------------------------------------
; Vstup: X - Prvni cislo souboru
;        Y - Druhe cislo souboru
;--------------------------------------
start           = *
                LDA     1
                PHA     
;                LDA     #$36            ;Vypne BASIC ROM
                lda #$37
                STA     1
                
                STX     byte_CD0C
                STY     byte_CD0D

                LDX     #2
loc_CD35      = *
                LDA     $0000,X
                STA     $CE00,X         ;Zalohuje nulovou stranku
                INX     
                BNE     loc_CD35
                
                LDA     byte_CD0C
                JSR     sub_CD10      ;Prevede na ASCII
                STX     a0
                STY     a0+1            ;prvni cislo
                
                LDA     byte_CD0D
                JSR     sub_CD10      ;prevede na ASCII
                STX     a0+3
                STY     a0+4            ;druhe cislo
                
                LDX     byte_CD0C
                LDY     byte_CD0D
                LDA     byte_CD03     ;????
                CPX     #$23
                BNE     loc_CD6A
                CPY     #0
                BNE     loc_CD6A
                                        ;Soubor se jmenuje: "23;00"                
                LDA     $C306           ;????

loc_CD6A        = *
                CLC     
                ADC     #$1B
                STA     a0+6

;                JSR     $FF8A           ;RESTOR !!!!

                LDA     byte_CD0B       ;cislo souboru
                TAX                     ;cislo zarizeni
                ldy #0                  ;sec. adresa
                JSR setlfs
                LDA     #7
                LDX     #<a0
                LDY     #>a0
                JSR setnam
                
                LDA     #0              ;vypne hlasky
                STA     $9D

                JSR open
                ldx byte_CD0B
                jsr chkin
                jsr read_file
                lda byte_CD0B
                jsr close

                PLA     
                STA     1               ;Obnovi $01

                LDX     #2
loc_CD9A        = *
                LDA     $CE00,X
                STA     $0000,X             ;Obnovi nulovou str.
                INX     
                BNE     loc_CD9A

                CLC     
                RTS                     ;### Konec
;--------------------------------------
;--------------------------------------
read_file       = *
loc_CDAC        = *
                JSR chrin
                STA     $AE
                JSR chrin
                STA     $AF
loc_CDB6        = *
                JSR chrin
                LDX     #1
                CMP     #$D7            ;komprese a/n 
                BNE     loc_CDD5
                JSR chrin
                CMP     #0
                BEQ loc_CDD3            ;Hodnota $b7 (nikoliv command)
                CMP     #1
                BEQ     loc_CDF1        ;CLOSE
                CMP     #2
                BEQ     loc_CDAC        ;Nova adresa ...
                
                TAX                     ;Pocet opakovani bajtu
                JSR chrin               ;Hodnota

                .byte $2c
loc_CDD3        = *
                lda #$d7

loc_CDD5        = *
                SEI     
                TAY     
                LDA $01
                PHA     
                TYA     
                LDY #0                 ;Vsude RAM
                STY $01

loc_CDDF        = *
                STA     ($AE),Y
                INC     $AE
                BNE     loc_CDE7
                INC     $AF

loc_CDE7        = *
                DEX     
                BNE     loc_CDDF
                PLA     
                STA $01                ;Obnovi $01
                BNE     loc_CDB6
                BEQ     loc_CDB6

loc_CDF1        = *
                rts
;--------------------------------------

